/*
 	This file is part of DataFox, a bandwidth usage monitor for 
 	BSNL DataOne broadband.
 	Author: Brian Fernandes - infernalproteus@gmail.com

    DataFox is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    DataFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DataFox; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
//var bRowExp = new RegExp('<tr>(\\s*<td class="ColorBlue"[^>]*[\\s\\S]*?</td>)+\\s*</tr>', 'gi');	
var bRowExp = new RegExp('<tr>(\\s*<td[^>]*class="ColorBlue"[^>]*[\\s\\S]*?</td>)+\\s*</tr>', 'gi');	
var bItemExp = new RegExp("<b>[\\s]*([^<]*)", "gi");
var mItemExp = new RegExp(">([ \\S]*?)<", "g");
var recExp = new RegExp("Showing[\\s\\S]*?(\\d+)[\\s\\S]*?of[\\s\\S]*?(\\d+)[\\s\\S]*?Records", 'gi');
var dateExp = new RegExp('<Option value="(.*)" selected>', "gi");

var mbUsed = new RegExp("MB Used[\\s\\S]*?(\\d*\\.?\\d+)", "gi");
var adslFree = new RegExp("ADSL MB[\\s\\S]*?(\\d*\\.?\\d+)", "gi");
var nightMB = new RegExp("NightMB[\\s\\S]*?(\\d*\\.?\\d+)", "gi");

DFox.prototype.mtnlBOMLogin = function() {
	this.phase = this.GET_SUPPLIES;
	var pData = "username=" + this.username + "&btnSubmit=View%20Current%20Month%20Sessions";
//	this.eval(this.createEquateString("this.openURLPD2", "username=" + this.username + "&btnSubmit=View%20Session%20History&ondemsrv=yes&loginID=LOGOUT"));
//	this.eval(this.createEquateString("this.openURLPD2", "telno=" + this.username + "&btnSubmit=View%20Last%20Month%20Sessions"));
	talkToServer("http://register.mtnl.net.in/cgi-bin/sessdetr.cgi", pData, null, null, this);
};

DFox.prototype.mtnlDELLogin = function() {
	this.mtnlDate = new Date();
	
	this.phase = this.LOGIN;
	var pData = "login=" + this.username + "&password=" + this.password + "&sessionState=start&page=login_verify&service=mtnl/adsl&Component=com.portal.web.comp.PLoginBeanImpl";
	this.domain = "webkit.mtnldelhi.in/htmlui_en";		
	talkToServer("http://" + this.domain + "/PInfranetServlet", pData, null, null, this, false, 5*1000);	
};

DFox.prototype.mtnlBOMResponseHandler = function(data) {
	if (this.phase == this.GET_SUPPLIES) {
		this.parseMTNLBOMUsageData(data);
	}
};

DFox.prototype.mtnlDELResponseHandler = function(data) {
	switch(this.phase) {
		case this.LOGIN:
			this.phase = this.GET_SUPPLIES;
			if (data.indexOf("Successful Login") == -1) {
				this.log("Error logging in");
				this.setState(this.ERROR, "Check your username and password");
				break;
			}
			talkToServer("http://" + this.domain + "/PostpaidViewAcctInfo.jsp", null, null, null, this);	
			break;
		case this.GET_SUPPLIES:
			/*var pData = "startday=1&startmonth=2&startyear=2007&endday=28&endmonth=2&endyear=2007"; //&referrer=SessionHistoryServlet";
			this.eval(this.createEquateString("this.openURLPD", pData));
			talkToServer("http://" + this.domain + "/SessionHistoryServlet", pData, null, null, this);*/
			this.parseMTNLDELUsageData(data);
			break;				
	}		
}


//This routine obtains the actual session history - unnecessary because the records are incomplete and incorrect
DFox.prototype.mtnlDELResponseHandlerAdvanced = function(data) {
	switch(this.phase) {
		case this.LOGIN:
			this.phase = this.SET_PARAMS;
			if (data.indexOf("Successful Login") == -1) {
				this.log("Error logging in");
				this.setState(this.ERROR, "Check your username and password");
				break;
			}
			
			//check the server date if necessary 			
			//if (this.mtnlDate.getHours() == 0 && this.mtnlDate.getMinutes() < 30) {
			if (1) {
				//it's between 0000 and 0030, we need to check the server date
				this.phase = this.ZERO_CONTACT;			
			} else {
				this.phase = this.SET_PARAMS;
			}
			
			talkToServer("http://" + this.domain + "/PostpaidViewAcctInfo.jsp", null, null, null, this);	
			break;
		case this.ZERO_CONTACT:
			//get the sever date
			this.phase = this.FIRST_CONTACT;
			talkToServer("http://" + this.domain + "/SessionHistorySelection.jsp", null, null, null, this);							
			break;	
		case this.FIRST_CONTACT:
			var values = data.match(dateExp);
			values = values.join(",");
			var nums = values.match(/\d+/g);
			this.log(nums);
			this.mtnlDate.setTime(Date.parse(nums[1] + "/" + nums[0] + "/" + nums[2]));			
			this.log(this.mtnlDate);
			//fall through
		case this.SET_PARAMS:
			this.phase = this.GET_SUPPLIES;
			this.log(data);
			var pData = "startday=1&startmonth=2&startyear=2007&endday=28&endmonth=2&endyear=2007"; //&referrer=SessionHistoryServlet";
			talkToServer("http://" + this.domain + "/SessionHistoryServlet", pData, null, null, this);
			break;				
		case this.GET_SUPPLIES:			
			this.log("parsing mtnl Delhi returned data");
			//initialize the mtnl data
			this.mtnlData = "";
			this.parseMTNLDELUsageData(data);
			break;	
		case this.GET_NEXT_PAGE:
			this.parseMTNLDELUsageData(data);			
			break;
	}	
};

DFox.prototype.parseMTNLBOMUsageData = function (aData) {
	this.tableToArray(aData, true);
};

DFox.prototype.parseMTNLDELUsageData = function(aData) {
	mbUsed.lastIndex = 0;
	adslFree.lasIndex = 0;
	nightMB.lastIndex = 0;
	
	var used, night, free;
	
	try {
		used  = parseFloat(mbUsed.exec(aData)[1]) * 1024;	
		free = parseFloat(adslFree.exec(aData)[1]) * 1024;
		var temp = nightMB.exec(aData)
		if (temp && temp.length == 2) {
			night = parseFloat(temp[1]) * 1024;
		}
	} catch (e) {
		this.setState(this.ERROR, "Usage data N/A");
	}
	
	var cProps = new Object();
	cProps["dtR"] = used + (!isNaN(night) ? night : 0);
	cProps["dcX"] = cProps["dnX"] = used;
	cProps["drR"] = free;
	
	this.setState(this.LOGGEDIN);
	this.eval(this.createEquateString("this.cProps", cProps));
	this.refreshUI();
	this.log(used + "," + night + "," + free);
};

//This routine scans through pages of records - unnecessary because the records are incomplete and incorrect
DFox.prototype.parseMTNLDELUsageDataAdvanced = function(aData) {
	recExp.lastIndex = 0;
	var parts = recExp.exec(aData);
	
	//FIXME: check for missing part string here
	this.log(parts[1] + "," + parts[2]);
	
	this.mtnlData += aData;
	
	if (parseInt(parts[1]) < parseInt(parts[2])) {
		this.phase = this.GET_NEXT_PAGE;
		var pData = "hidRow="+parts[1]+"&hidMode=N";
		talkToServer("http://" + this.domain + "/SessionHistoryReport.jsp", pData, null, null, this);	
	} else {
		this.setState(this.LOGGEDIN);
		this.tableToArray(this.mtnlData, false);
		this.mtnlData = null;		
	}
	
};

DFox.prototype.tableToArray = function(aData, mtnl_bombay) {
	bRowExp.lastIndex = 0;
	
	var results = aData.match(bRowExp);
	if (!results || results.length < 3) {
		this.setState(this.ERROR, "Usage data N/A");
		return null;
	}
	
	this.log(results.length);
	
	var tOffset;
	var uOffset;
	var itemExp;
	
	if (mtnl_bombay) {
		tOffset = 0;
		uOffset = 4;
		itemExp = bItemExp;
		start = 0;
		end = results.length - 1;
	} else {
		tOffset = 5;
		uOffset = 2;
		itemExp = mItemExp;
		start = 0;
		end = results.length;
	}
	
	var totalUp = 0;
	var nTotalUp = 0;
	var totalDown = 0;
	var nTotalDown = 0;
	
	var totalMS = 0;
	
	for (var i = start; i < end; i++) {
//		this.log(results[i]);
		itemExp.lastIndex = 0;
		var values = new Array();		
		while ((res2 = itemExp.exec(results[i])) != undefined) {		
//			this.log("res " + res2[1]);
			values.push(res2[1]);
		}		
		var t1 = new Date();
		
		var temp = Date.parse(values[tOffset]);
		//if this is a non data row, this value will be NaN
		if (isNaN(temp)) continue;
				
		t1.setTime(temp);
		var t2 = new Date();
		t2.setTime(Date.parse(values[tOffset+1]));
		var downloaded = parseFloat(values[3]);
		var uploaded = parseFloat(values[uOffset]);	
				
		totalMS += t2 - t1;	
		totalUp += uploaded;
		totalDown += downloaded;
		if (isBetween12_8(t1, t2)) {
			nTotalUp += uploaded;
			nTotalDown += downloaded;
		}			
		
	}
	
	var hours = totalMS / (60 * 60 * 1000);
	hours = Math.round(ROUND_TO * hours) / ROUND_TO;
	
	//convert to KB
	totalUp /= 1024;
	totalDown /= 1024;
	nTotalUp /= 1024;
	nTotalDown /= 1024;
	
	/*this.eval(this.createEquateString("this.tSend", totalUp, 
									  "this.tRecv", totalDown, 
									  "this.tXfer", totalUp + totalDown, 
									  "this.uSend", nTotalUp,
									  "this.uRecv", nTotalDown,
									  "this.nXfer", totalDown - nTotalDown,
									  "this.tHours", hours));*/
	
	var cProps = new Object();
	cProps["dtS"] = totalUp;
	cProps["dtR"] = cProps["dcX"] = cProps["dnX"] = totalDown;
	cProps["dtX"] = totalUp + totalDown;
	cProps["ntH"] = hours;
	
	this.setState(this.LOGGEDIN);	
	this.eval(this.createEquateString("this.cProps", cProps));	
	this.refreshUI();
	this.log("Up: " + totalUp + "/" + nTotalUp + ", Down:" + totalDown + "/" + nTotalDown + ", Time: " + totalMS / (60 * 60 * 1000));
	
};

DFox.prototype.mtnlBOMOpenInBrowser = function(openRecords) {
	var pd = openRecords 	? "telno=" + this.username + "&btnSubmit=View%20Last%20Month%20Sessions"
							: "username=" + this.username + "&btnSubmit=View%20Current%20Month%20Sessions";
	openInBrowser("http://register.mtnl.net.in/cgi-bin/sessdetr.cgi", pd);	
};

DFox.prototype.mtnlDELOpenInBrowser = function(openRecords) {	
	var sDate = new Date();
	var eDate = new Date();
	eDate.setTime(sDate.getTime());
	sDate.setDate(1);	
	if (openRecords) {
		//open last month's details		
		sDate.setMonth(sDate.getMonth()-1);		
		eDate.setDate(0);
	}
		
	var pData = "startday=" + sDate.getDate() + "&startmonth=" + (sDate.getMonth() + 1) + "&startyear=" + sDate.getFullYear() + 
				"&endday=" + eDate.getDate() + "&endmonth=" + (eDate.getMonth() + 1) + "&endyear=" + eDate.getFullYear();
	this.log(pData);
	openInBrowser("http://" + this.domain + "/SessionHistoryServlet", pData, null, null, this);	
};